!= Module FileSet_3d
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu
! Version::   $Id: fileset_3d.f90,v 1.5 2011-03-28 01:48:54 sugiyama Exp $ 
! Tag Name::  $Name: arare4-20110328 $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!Ϳ줿 NAMELIST ե뤫, ե̾ɽξ
!ݴɤ뤿ѿ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module fileset_3d
  !
  !Ϳ줿 NAMELIST ե뤫, I/O ե̾, 
  !ݴɤ뤿ѿ⥸塼
  !

  !⥸塼ɤ߹
  use dc_types,      only : STRING 
  use dc_iounit,     only : FileOpen
  use dc_message,    only : MessageNotify
  use gtool_history, only : gt_history

  use gridset_3d,     only: SpcNum       !Žʬο
  use basicset_3d,    only: SpcWetSymbol !ʬβؼ̾

  !ۤηػ
  implicit none

  !ѿ
  character(STRING), save, public :: InitFile          = ""                    !ͥե
  character(STRING), save, public :: InitFilePrefix    = ""                    !ͥե
  character(STRING), save, public :: HistoryFilePrefix = "deepconv"            !ҥȥ꡼եƬ
  character(STRING), save, public :: ReStartFile       = ""                    !ꥹȥե
  character(STRING), save, public :: RandomFile        = "rand.dat"            !ե
  character(STRING), save, public :: ExpTitle = "2D cumulus model deepconv/arare"         !ǡɽ
  character(STRING), save, public :: ExpSrc   = "GFD_Dennou_Club deepconv project (arare)"!ǡ
  character(STRING), save, public :: ExpInst  = "deepconv@gfd-dennou.org"                 !ǽѹԡȿ
  type(gt_history),allocatable, save, public   :: gt_hist(:)                   !gt_history ¤
  character(STRING), allocatable, save, public :: HistoryFile(:)               !ϥե̾
  integer, save, public           :: FileNum = 12                              !ϥե
  character(3), save              :: Rank                                      !Ρֹ
  integer, save                   :: myrank
!  character(80) :: InitFile          !ͥե
!  character(80) :: HistoryFilePrefix !ҥȥ꡼եƬ
!  character(80) :: ReStartFile       !ꥹȥե
!  character(80) :: RandomFile        !ե
!  character(80) :: ExpTitle          !ǡɽ
!  character(80) :: ExpSrc            !ǡ
!  character(80) :: ExpInst           !ǽѹԡȿ
!  character(100), allocatable :: HistoryFile(:) !ϥե̾
!  integer                         :: FileNum        !ϥե
!  type(gt_history),allocatable    :: gt_hist(:)     !gt_history ¤

contains

  subroutine fileset_init(cfgfile, cpurank)
    !
    !NAMELIST ե̾դ륿, ϥե̾. 
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    character(*), intent(in)      :: cfgfile
    integer, intent(in), optional :: cpurank    

    !ѿ
    integer                  :: unit     !ֹ
    integer                  :: s        !롼ź
    
    !NAMELIST 
    NAMELIST /fileset/                                  &
      & InitFile, HistoryFilePrefix, ReStartFile, RandomFile, &
      & ExpTitle, ExpSrc           , ExpInst
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=fileset)
    close(unit)
    
    !ΡֹѰ
    if (present(cpurank)) then 
      myrank = cpurank
    end if
    call fileset_setnum()    
   
    !ե̾Ǽγդ
    !  
    !    PotTemp, Exner, VelX, VelY, VelZ, MixRt(SpcNum), Km, Kh
    !    VorX, VorY, VorZ
    !    *BasicZ, *Zprof
    !  ι 12 + SpcNum  

    FileNum = 12 + SpcNum
    allocate(HistoryFile(FileNum))
    allocate(gt_hist(FileNum))

    ! InitFile  InitFilePrefix Ǥʤ, InitFilePrefix 
    if (trim(InitFile) == '' .AND. trim(InitFilePrefix) /= '') then 
      InitFile = trim(InitFilePrefix)//"-rank"//trim(rank)//"_restart.nc"
    end if

    HistoryFile(1) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_Exner.nc" 
    HistoryFile(2) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_PotTemp.nc" 
    HistoryFile(3) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_VelX.nc" 
    HistoryFile(4) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_VelY.nc" 
    HistoryFile(5) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_VelZ.nc" 
    HistoryFile(6) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_Km.nc" 
    HistoryFile(7) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_Kh.nc" 
    HistoryFile(8) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_BasicZ.nc" 
    HistoryFile(9) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_Zprof.nc" 
    HistoryFile(10) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_VorX.nc" 
    HistoryFile(11) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_VorY.nc" 
    HistoryFile(12) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_VorZ.nc" 

    do s = 1, SpcNum
      HistoryFile(12+s) = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_"//trim(SpcWetSymbol(s))//".nc"
    end do

    !ꥹȥե
    if (RestartFile == "") then 
      ReStartFile  = trim(HistoryFilePrefix)//"-rank"//trim(rank)//"_restart.nc" 
    end if
    
    !ǧ
    call MessageNotify( "M", &
      & "fileset_init", "InitFile=%c",    c1=trim(InitFile))
    do s = 1, Filenum
      call MessageNotify( "M", &
        & "fileset_init", "HistoryFile=%c", c1=trim(HistoryFile(s)) )
    end do
    call MessageNotify( "M", &
      & "fileset_init", "ReStartFile=%c", c1=trim(ReStartFile) )
    call MessageNotify( "M", &
      & "fileset_init", "RandomFile=%c",  c1=trim(RandomFile) )
    call MessageNotify( "M", &
      & "fileset_init", "ExpTitle=%c",    c1=trim(ExpTitle) )
    call MessageNotify( "M", &
      & "fileset_init", "ExpSrc=%c",      c1=trim(ExpSrc) )
    call MessageNotify( "M", &
      & "fileset_init", "ExpInst=%c",     c1=trim(ExpInst) )
    
  end subroutine fileset_init

  subroutine fileset_setnum()

   !Ρֹʸ
   rank = "000"
   if (myrank < 10) then 
     write(rank(3:3), 100) myrank
100  format(I1)
   else if (myrank < 100 ) then 
     write(rank(2:3), 200) myrank
200  format(I2)
   else if (myrank < 1000 ) then 
     write(rank(1:3), 300) myrank
300  format(I3)
   end if
 end subroutine fileset_setnum

end module fileset_3d
